Skip to main content

IProject interface

The IProject interface deals with an open project in Altium Designer. There are project and document variants, that is actually a project or document can be specified to have project or document variants (actual project / document variants do not exist) and on these document variants have component variants.

public interface IProject : IDMObject

Namespace: EDP · Assembly: Altium.SDK.Interfaces

Inherits: IDMObject

Derived: IAbstractVHDLProject, IBoardProject, IEmbeddedProject, IFreeDocumentsProject, IIntegratedLibraryProject

Remarks​

To have access to the data of a project, you need to do a compile first. Projects deal with logical and physical documents. Logical documents are the connected documents which are part of a design which include a PCB document associated with this design. Physical documents are source documents expanded by the Altium Designer compiler as in a flattened design project.

Thus, a project contains source documents and implementation documents. To have access to the most current data of a project, you need to compile the project first. The compiler maps (or expands) all the logical source documents into physical documents.

Normally there is a one logical document to a one physical document for a simple flat design project, but for hierarchical design projects (for example multi channel projects), the documents that have sheet symbols with a Repeat statement, then logical documents are expanded into multiple physical documents.

There are Output jobs consisting of available output generators installed in Altium Designer.

Methods​

MethodReturnsDescription
DM_AddConfigurationIConfiguration
DM_AddConfigurationParametersvoidA configuration is a list of constraints file which manages the mapping of pins to ports of a FPGA project.
DM_AddConfigurationParameters_PhysicalvoidA configuration is a list of constraints file which manages the mapping of pins to ports of a FPGA project.
DM_AddControlPanelvoidThe method adds a document to the main section of the the panel which could be part of a project or free documents.
DM_AddDeviceSheetFoldervoid
DM_AddGeneratedDocumentvoidThis method adds a new generated document referenced by its filename parameter in this current project, and this document appears in theGenerated folder of this project on Altium Designer Projects pa…
DM_AddParametervoid
DM_AddProjectVariantIProjectVariant
DM_AddSearchPathvoidThis method adds a new serach path for the current project.
DM_AddSourceDocumentvoidThe method adds a source document referenced by its filename parameter in the current project.
DM_AvailableDatabaseLinksbool
DM_BeginUpdatevoid
DM_ChannelDesignatorFormatstringThis method returns the formatted channel designator string.
DM_ChannelRoomLevelSeperatorstringThe method returns the separator character for the Channel Room Level string.
DM_ChannelRoomNamingStyleTChannelRoomNamingStyleThe method returns the TChannelRoomNamingStyle type.
DM_ClearViolationsvoidThe method clears all existing violations within the project.
DM_CompileboolInvoke this method to compile the current project.
DM_CompileExboolInvoke this method to compile all documents of all opened projects in Altium Designer.
DM_ComponentMappingsIComponentMappingsThe method returns the IComponentMapping interface which details which PCB components are linked to Schematic components.
DM_ComponentMappings_1IComponentMappings
DM_ConfigurationCountintThe method returns the number of configurations for the current project.
DM_ConfigurationsIConfigurationThe method returns the indexed configuration of a FPGA project.
DM_CurrentProjectVariantIProjectVariantThe method returns the current project variant from this current project.
DM_DataModelIUnifiedDataModel
DM_DeviceSheetFolderCountint
DM_DeviceSheetFoldersIDeviceSheetFolder
DM_DoCrossSelectionvoidActivates the cross probing method where you can jump from a Schematic object to its corresponding PCB object (both source and primary implementation documents need to be open in Altium Designer).
DM_DocumentBackupsIDocumentBackups
DM_DocumentFlattenedIDocumentThe method returns the flattened document.
DM_EditConfigurationsbool
DM_EditOptionsbool
DM_EndUpdatevoid
DM_EnsureAllCachedManagedOutputJobsvoid
DM_EnsureStandardConfigurationsvoid
DM_ErrorLevelsTErrorLevelThe method returns the error level for the specified error type.
DM_GeneratedDocumentCountintThe method returns the number of generated documents such as those documents generated by the OutPut generator (from a OutJob document).
DM_GeneratedDocumentsIDocumentThe method returns the indexed generated document which is generated by the Output Generator.
DM_GetAllowPortNetNamesboolInvoke this method to check whether port net names are used for navigation in Altium Designer or not.
DM_GetAllowSheetEntryNetNamesboolInvoke this method to check whether sheet entry net anmes are used for navigation in Altium Designer or not.
DM_GetAppendSheetNumberToLocalNetsboolInvoke this method to check whether sheet numbers are appended to local nets or not.
DM_GetConfigurationByNameIConfigurationThe method returns you the configuration object for the project (normally for FPGA projects) if configuration parameter is valid.
DM_GetDefaultConfigurationIConfigurationThe method returns the default configuration for a FPGA project.
DM_GetDefaultConfigurationNamestringReturns the name of the default configuration for a FPGA project
DM_GetDefaultPcbTypestring
DM_GetDocumentByDocumentIdIDocument
DM_GetDocumentFromPathIDocumentThis method returns the IDocument interface associated with the document path parameter.
DM_GetLinkedManagedProjectGUIDstring
DM_GetOutputPathstringThe method returns the output path for generated documents for the current project.
DM_GetPinSwapBy_Netlabelbool
DM_GetPinSwapBy_Pinbool
DM_GetReleaseVaultGUIDstring
DM_GetScrapDocumentIDocumentReturns the scrap document for the project.
DM_GetTopLevelDocumentStructureIDocumentStructure
DM_GetWebURLstring
DM_GlobalPreferencesRevisionGUIDstring
DM_GlobalPreferencesVaultGUIDstring
DM_HierarchyModeTFlattenModeThis method returns the hierarchy mode as a TFlattenMode parameter.
DM_HierarchyModeForCompileTFlattenMode
DM_InCompilationbool
DM_IndexOfSourceDocumentintThe method returns the index of the source document based on the filename of this document.
DM_InitializeOutputPathstringReturns the output path for the Output Generator based on the output type.
DM_LogicalDocumentCountintThe method returns the number of logical documents which represent the actual documents of a design project (documents that exist in the design project but are not part of the design are not logical…
DM_LogicalDocumentsIDocumentThe method returns the indexed logical document of a project.
DM_ManagedParameterCountint
DM_ManagedParametersIParameter
DM_ManagedProjectGUIDstring
DM_MoveSourceDocumentvoidThe method re-assigns the source document referenced by the filename a new index number.
DM_NeedsCompilebool
DM_OptionsStorageIOptionsStorage
DM_OutputersIOutputerThe method returns the indexed Output Generator.
DM_OwnedProjectCountint
DM_OwnedProjectsIProject
DM_PhysicalDocumentCountintThe method returns the number of physical source documents (which are expanded logical documents of the design project).
DM_PhysicalDocumentsIDocumentThe method returns the indexed physical document of a project.
DM_PrimaryImplementationDocumentIDocumentThe method returns the primary implementation document for example PCB documents.
DM_ProjectFileNamestringThis method returns the file name of this current project in Altium Designer.
DM_ProjectFullPathstringThis method returns the full path of this current project in Altium Designer.
DM_ProjectTemplateLocationstring
DM_ProjectVariantCountintThe method returns the number of project variants for this current project.
DM_ProjectVariantsIProjectVariantThe method returns the indexed IProjectVariant interface.
DM_RefreshInWorkspaceFormvoid
DM_ReleaseProjectCopyIProject
DM_RemoveAllConfigurationsbool
DM_RemoveConfigurationByNamebool
DM_RemoveProjectVariantvoid
DM_RemoveSourceDocumentvoidThis method removes a source document referenced by its filename from this current project.
DM_ReportSuppressedErrorsInMessagesbool
DM_ResetReleaseProjectvoid
DM_SearchPathCountintThe method returns the number of search paths for this current project.
DM_SearchPathsISearchPathThe method returns the indexed search path object defined for this project.
DM_ServerDocumentIServerDocument
DM_SetAllowPortNetNamesvoidInvoke this method to allow port net names be used for navigation.
DM_SetAllowSheetEntryNetNamesvoidInvoke this method to allow sheet entry net names be used for navigation in Altium Designer.
DM_SetAppendSheetNumberToLocalNetsvoidInvoke this method to have the ability to append sheet numbers to local nets on a document / project.
DM_SetAsCurrentProjectvoidInvoke this method to set the project as the current project in Altium Designer.
DM_SetCurrentProjectVariantvoid
DM_SetDefaultConfigurationNamevoidThe method sets the name for the default configuration of a FPGA project.
DM_SetDefaultPcbTypevoid
DM_SetErrorLevelsvoid
DM_SetHierarchyModevoidInvoke this method to set which hierarchy mode for this project.
DM_SetLinkedManagedProjectGUIDvoid
DM_SetManagedProjectGUIDvoid
DM_SetOutputPathvoidSets the output path for generated documents to go in by the Altium Designer output generator.
DM_SetPinSwapBy_Netlabelvoid
DM_SetPinSwapBy_Pinvoid
DM_SetReleaseVaultGUIDvoid
DM_StartCrossProbingvoidThis method invokes the cross probing method.
DM_StartNavigationvoidThis method invokes the navigation panel for the current project.
DM_ToDoManagerIToDoManagerInvoke this method to have access to the IToDoManager object.
DM_TopLevelLogicalDocumentIDocumentThis method returns the top level logical document of this current project.
DM_TopLevelPhysicalDocumentIDocumentThis method returns the top level physical document of this current project.
DM_TryToResolveDocumentSpecialStringbool
DM_TryToResolveSpecialStringbool
DM_UpdateConstraintsboolInvoke this method to update the constraint files used for a FPGA project and for corresponding PCB projects with FPGA components.
DM_UserIDstringThe method returns a value that represents the UserID of the project.
DM_ViolationCountintThis method returns the number of violations reported by Altium Designer for this current project.
DM_ViolationsIViolationReturns the indexed violation for a current project.
GetNavigationHistoryINavigationHistoryThis method returns the status of the navigation buttons on the Navigator panel for the current project in Altium Designer.

DM_AddConfiguration​

No description yet.

IConfiguration DM_AddConfiguration(string argConfiguration);
ParameterTypePassing
argConfigurationstringvalue

Returns: IConfiguration

Extension method of IProjectHelper (using EDP;).

DM_AddConfigurationParameters​

A configuration is a list of constraints file which manages the mapping of pins to ports of a FPGA project. Invoke this method to add parameters of a specified configuration file for a FPGA project.

void DM_AddConfigurationParameters(string argConfiguration);
ParameterTypePassing
argConfigurationstringvalue

Returns: nothing (void)

DM_AddConfigurationParameters_Physical​

A configuration is a list of constraints file which manages the mapping of pins to ports of a FPGA project. Invoke this method to add parameters of a specified configuration file for a FPGA project.

void DM_AddConfigurationParameters_Physical(string argConfiguration);
ParameterTypePassing
argConfigurationstringvalue

Returns: nothing (void)

DM_AddControlPanel​

The method adds a document to the main section of the the panel which could be part of a project or free documents.

void DM_AddControlPanel(string argFilename);
ParameterTypePassing
argFilenamestringvalue

Returns: nothing (void)

DM_AddDeviceSheetFolder​

No description yet.

void DM_AddDeviceSheetFolder(string argFolderPath, bool argIncludeSubFolders);
ParameterTypePassing
argFolderPathstringvalue
argIncludeSubFoldersboolvalue

Returns: nothing (void)

DM_AddGeneratedDocument​

This method adds a new generated document referenced by its filename parameter in this current project, and this document appears in theGenerated folder of this project on Altium Designer Projects panel.

void DM_AddGeneratedDocument(string argFilename);
ParameterTypePassing
argFilenamestringvalue

Returns: nothing (void)

DM_AddParameter​

No description yet.

void DM_AddParameter(string argName, string argValue);
ParameterTypePassing
argNamestringvalue
argValuestringvalue

Returns: nothing (void)

DM_AddProjectVariant​

No description yet.

IProjectVariant DM_AddProjectVariant();

Returns: IProjectVariant

Extension method of IProjectHelper (using EDP;).

Examples: Extension_AddVariant, Extension_CreateVariantComponent

DM_AddSearchPath​

This method adds a new serach path for the current project.

void DM_AddSearchPath(string argSearchPath, bool argIncludeSubFolders);
ParameterTypePassing
argSearchPathstringvalue
argIncludeSubFoldersboolvalue

Returns: nothing (void)

DM_AddSourceDocument​

The method adds a source document referenced by its filename parameter in the current project.

void DM_AddSourceDocument(string argFilename);
ParameterTypePassing
argFilenamestringvalue

Returns: nothing (void)

Examples: Extension_CreateProject, Extension_GenerateGerber

No description yet.

bool DM_AvailableDatabaseLinks();

Returns: bool

DM_BeginUpdate​

No description yet.

void DM_BeginUpdate();

Returns: nothing (void)

Examples: Extension_AddVariant, Extension_CreateVariantComponent

DM_ChannelDesignatorFormat​

This method returns the formatted channel designator string. This string is basedon the settings defined in the Multi-Channel page of the Options for Project dialog from the Project » Project Options menu item.

string DM_ChannelDesignatorFormat();

Returns: string

DM_ChannelRoomLevelSeperator​

The method returns the separator character for the Channel Room Level string. The default is an underline character used for room naming styles when there are paths (based on hierarchical designs).

string DM_ChannelRoomLevelSeperator();

Returns: string

DM_ChannelRoomNamingStyle​

The method returns the TChannelRoomNamingStyle type. There are alternative styles for naming rooms on a PCB document.

TChannelRoomNamingStyle DM_ChannelRoomNamingStyle();

Returns: TChannelRoomNamingStyle

Extension method of IProjectHelper (using EDP;).

DM_ClearViolations​

The method clears all existing violations within the project.

void DM_ClearViolations();

Returns: nothing (void)

DM_Compile​

Invoke this method to compile the current project. Once the project is compiled, navigation of nets and comparing the differences of documents and other tasks can be performed.

bool DM_Compile();

Returns: bool

Examples: Extension_AddVariant, Extension_BOMManager, Extension_CreateVariantComponent, Extension_HierarchicalDesign, Extension_TestPortHarnessDev

DM_CompileEx​

Invoke this method to compile all documents of all opened projects in Altium Designer. Pass a Boolean parmeter in to cancel the compiling process.

bool DM_CompileEx(bool argll, ref bool argCancelled);
ParameterTypePassing
argllboolvalue
argCancelledboolref

Returns: bool

DM_ComponentMappings​

The method returns the IComponentMapping interface which details which PCB components are linked to Schematic components. Check the IComponentMappings interface.

IComponentMappings DM_ComponentMappings(string argnImplementationDocument);
ParameterTypePassing
argnImplementationDocumentstringvalue

Returns: IComponentMappings

Extension method of IProjectHelper (using EDP;).

DM_ComponentMappings_1​

No description yet.

IComponentMappings DM_ComponentMappings_1(string argSourceDocument, string argnImplementationDocument);
ParameterTypePassing
argSourceDocumentstringvalue
argnImplementationDocumentstringvalue

Returns: IComponentMappings

Extension method of IProjectHelper (using EDP;).

DM_ConfigurationCount​

The method returns the number of configurations for the current project. To be used in conjunction with DM_Configurations method.

int DM_ConfigurationCount();

Returns: int

DM_Configurations​

The method returns the indexed configuration of a FPGA project. A configuration can have a list of different constraint files.

IConfiguration DM_Configurations(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IConfiguration

Extension method of IProjectHelper (using EDP;).

DM_CurrentProjectVariant​

The method returns the current project variant from this current project. Check out the IProjectVariant interface.

IProjectVariant DM_CurrentProjectVariant();

Returns: IProjectVariant

Extension method of IProjectHelper (using EDP;).

Examples: Extension_BOMManager, Extension_GenerateGerber

DM_DataModel​

No description yet.

IUnifiedDataModel DM_DataModel();

Returns: IUnifiedDataModel

Extension method of IProjectHelper (using EDP;).

Examples: Extension_TestPortHarnessDev

DM_DeviceSheetFolderCount​

No description yet.

int DM_DeviceSheetFolderCount();

Returns: int

DM_DeviceSheetFolders​

No description yet.

IDeviceSheetFolder DM_DeviceSheetFolders(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IDeviceSheetFolder

Extension method of IProjectHelper (using EDP;).

DM_DoCrossSelection​

Activates the cross probing method where you can jump from a Schematic object to its corresponding PCB object (both source and primary implementation documents need to be open in Altium Designer).

void DM_DoCrossSelection();

Returns: nothing (void)

DM_DocumentBackups​

No description yet.

IDocumentBackups DM_DocumentBackups();

Returns: IDocumentBackups

Extension method of IProjectHelper (using EDP;).

DM_DocumentFlattened​

The method returns the flattened document. A flattened document is part of a flattened hierarchy of a project and all objects of this project appear in the Instance list of the Navigator panel.

IDocument DM_DocumentFlattened();

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

Examples: Extension_AddVariant, Extension_BOMManager, Extension_CreateVariantComponent, Extension_HierarchicalDesign

DM_EditConfigurations​

No description yet.

bool DM_EditConfigurations();

Returns: bool

DM_EditOptions​

No description yet.

bool DM_EditOptions(string argDefaultPage);
ParameterTypePassing
argDefaultPagestringvalue

Returns: bool

DM_EndUpdate​

No description yet.

void DM_EndUpdate();

Returns: nothing (void)

Examples: Extension_AddVariant, Extension_CreateVariantComponent

DM_EnsureAllCachedManagedOutputJobs​

No description yet.

void DM_EnsureAllCachedManagedOutputJobs();

Returns: nothing (void)

DM_EnsureStandardConfigurations​

No description yet.

void DM_EnsureStandardConfigurations();

Returns: nothing (void)

DM_ErrorLevels​

The method returns the error level for the specified error type. For each violation type, you can have up to four different error levels, No Report, Warning, Error and Fatal Error with four different colored folders.

TErrorLevel DM_ErrorLevels(TErrorKind argErrorKind);
ParameterTypePassing
argErrorKindTErrorKindvalue

Returns: TErrorLevel

Extension method of IProjectHelper (using EDP;).

DM_GeneratedDocumentCount​

The method returns the number of generated documents such as those documents generated by the OutPut generator (from a OutJob document). Use this method in conjunction with the DM_GeneratedDocuments method.

int DM_GeneratedDocumentCount();

Returns: int

DM_GeneratedDocuments​

The method returns the indexed generated document which is generated by the Output Generator.

IDocument DM_GeneratedDocuments(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_GetAllowPortNetNames​

Invoke this method to check whether port net names are used for navigation in Altium Designer or not.

bool DM_GetAllowPortNetNames();

Returns: bool

DM_GetAllowSheetEntryNetNames​

Invoke this method to check whether sheet entry net anmes are used for navigation in Altium Designer or not.

bool DM_GetAllowSheetEntryNetNames();

Returns: bool

DM_GetAppendSheetNumberToLocalNets​

Invoke this method to check whether sheet numbers are appended to local nets or not.

bool DM_GetAppendSheetNumberToLocalNets();

Returns: bool

DM_GetConfigurationByName​

The method returns you the configuration object for the project (normally for FPGA projects) if configuration parameter is valid. A configuration file contains mapping information to link from a FPGA project to a linked PCB project.

IConfiguration DM_GetConfigurationByName(string argConfiguration);
ParameterTypePassing
argConfigurationstringvalue

Returns: IConfiguration

Extension method of IProjectHelper (using EDP;).

DM_GetDefaultConfiguration​

The method returns the default configuration for a FPGA project.

IConfiguration DM_GetDefaultConfiguration();

Returns: IConfiguration

Extension method of IProjectHelper (using EDP;).

DM_GetDefaultConfigurationName​

Returns the name of the default configuration for a FPGA project

string DM_GetDefaultConfigurationName();

Returns: string

DM_GetDefaultPcbType​

No description yet.

string DM_GetDefaultPcbType();

Returns: string

DM_GetDocumentByDocumentId​

No description yet.

IDocument DM_GetDocumentByDocumentId(string argDocumentId);
ParameterTypePassing
argDocumentIdstringvalue

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_GetDocumentFromPath​

This method returns the IDocument interface associated with the document path parameter. Otherwise a null value is returned.

IDocument DM_GetDocumentFromPath(string argDocumentPath);
ParameterTypePassing
argDocumentPathstringvalue

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_GetLinkedManagedProjectGUID​

No description yet.

string DM_GetLinkedManagedProjectGUID();

Returns: string

DM_GetOutputPath​

The method returns the output path for generated documents for the current project.

string DM_GetOutputPath();

Returns: string

DM_GetPinSwapBy_Netlabel​

No description yet.

bool DM_GetPinSwapBy_Netlabel();

Returns: bool

DM_GetPinSwapBy_Pin​

No description yet.

bool DM_GetPinSwapBy_Pin();

Returns: bool

DM_GetReleaseVaultGUID​

No description yet.

string DM_GetReleaseVaultGUID();

Returns: string

DM_GetScrapDocument​

Returns the scrap document for the project. A scrap document is a temporary document used when creating a new document and once a document is saved, the contents of the scrap document is copied and freed.

IDocument DM_GetScrapDocument(string argDocumentPath);
ParameterTypePassing
argDocumentPathstringvalue

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_GetTopLevelDocumentStructure​

No description yet.

IDocumentStructure DM_GetTopLevelDocumentStructure();

Returns: IDocumentStructure

Extension method of IProjectHelper (using EDP;).

DM_GetWebURL​

No description yet.

string DM_GetWebURL(string argPage, string argOpenedFrom, bool argIncludeAuthToken);
ParameterTypePassing
argPagestringvalue
argOpenedFromstringvalue
argIncludeAuthTokenboolvalue

Returns: string

DM_GlobalPreferencesRevisionGUID​

No description yet.

string DM_GlobalPreferencesRevisionGUID();

Returns: string

DM_GlobalPreferencesVaultGUID​

No description yet.

string DM_GlobalPreferencesVaultGUID();

Returns: string

DM_HierarchyMode​

This method returns the hierarchy mode as a TFlattenMode parameter.

TFlattenMode DM_HierarchyMode();

Returns: TFlattenMode

Extension method of IProjectHelper (using EDP;).

DM_HierarchyModeForCompile​

No description yet.

TFlattenMode DM_HierarchyModeForCompile();

Returns: TFlattenMode

Extension method of IProjectHelper (using EDP;).

DM_InCompilation​

No description yet.

bool DM_InCompilation();

Returns: bool

DM_IndexOfSourceDocument​

The method returns the index of the source document based on the filename of this document. This is for hierarchical or connected schematic documents.

int DM_IndexOfSourceDocument(string argFilename);
ParameterTypePassing
argFilenamestringvalue

Returns: int

DM_InitializeOutputPath​

Returns the output path for the Output Generator based on the output type.

string DM_InitializeOutputPath(string argnOutputType);
ParameterTypePassingDescription
argnOutputTypestringvalueThe output type.

Returns: string

DM_LogicalDocumentCount​

The method returns the number of logical documents which represent the actual documents of a design project (documents that exist in the design project but are not part of the design are not logical documents). Use this method in conjunction with the DM_LogicalDocuments method.

int DM_LogicalDocumentCount();

Returns: int

Examples: Ciiva

DM_LogicalDocuments​

The method returns the indexed logical document of a project.

IDocument DM_LogicalDocuments(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

Examples: Ciiva

DM_ManagedParameterCount​

No description yet.

int DM_ManagedParameterCount();

Returns: int

DM_ManagedParameters​

No description yet.

IParameter DM_ManagedParameters(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IParameter

Extension method of IProjectHelper (using EDP;).

DM_ManagedProjectGUID​

No description yet.

string DM_ManagedProjectGUID();

Returns: string

DM_MoveSourceDocument​

The method re-assigns the source document referenced by the filename a new index number.

void DM_MoveSourceDocument(string argFilename, int argNewIndex);
ParameterTypePassing
argFilenamestringvalue
argNewIndexintvalue

Returns: nothing (void)

DM_NeedsCompile​

No description yet.

bool DM_NeedsCompile();

Returns: bool

Examples: Extension_AddVariant, Extension_BOMManager, Extension_CreateVariantComponent, Extension_HierarchicalDesign, Extension_TestPortHarnessDev

DM_OptionsStorage​

No description yet.

IOptionsStorage DM_OptionsStorage();

Returns: IOptionsStorage

Extension method of IProjectHelper (using EDP;).

DM_Outputers​

The method returns the indexed Output Generator. An output generator could be a Simple BOM.

IOutputer DM_Outputers(string argName);
ParameterTypePassing
argNamestringvalue

Returns: IOutputer

Extension method of IProjectHelper (using EDP;).

DM_OwnedProjectCount​

No description yet.

int DM_OwnedProjectCount();

Returns: int

DM_OwnedProjects​

No description yet.

IProject DM_OwnedProjects(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IProject

Extension method of IProjectHelper (using EDP;).

DM_PhysicalDocumentCount​

The method returns the number of physical source documents (which are expanded logical documents of the design project). Source documents are usually schematic documents. Use this method in conjunction with the DM_PhysicalDocuments method.

int DM_PhysicalDocumentCount();

Returns: int

DM_PhysicalDocuments​

The method returns the indexed physical document of a project.

IDocument DM_PhysicalDocuments(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_PrimaryImplementationDocument​

The method returns the primary implementation document for example PCB documents. Source documents are Schematic documents for example.

IDocument DM_PrimaryImplementationDocument();

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_ProjectFileName​

This method returns the file name of this current project in Altium Designer.

string DM_ProjectFileName();

Returns: string

DM_ProjectFullPath​

This method returns the full path of this current project in Altium Designer.

string DM_ProjectFullPath();

Returns: string

DM_ProjectTemplateLocation​

No description yet.

string DM_ProjectTemplateLocation();

Returns: string

DM_ProjectVariantCount​

The method returns the number of project variants for this current project.

int DM_ProjectVariantCount();

Returns: int

Examples: Extension_AddVariant, Extension_CreateVariantComponent

DM_ProjectVariants​

The method returns the indexed IProjectVariant interface. A project variant interface is only a conceptual representation of a project that can have project variants. That is there is only one physical board but this same board can have certain components disabled or enabled leading to document variants. The variations of a PCB board are referred to as the IDocumentVariant and to check which components are enabled or not for this particular document variant, check out the IComponentVariant interface.

IProjectVariant DM_ProjectVariants(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IProjectVariant

Extension method of IProjectHelper (using EDP;).

This is to be used in conjunction with the DM_ProjectVariantCount method.

Examples: Extension_AddVariant, Extension_CreateVariantComponent

DM_RefreshInWorkspaceForm​

No description yet.

void DM_RefreshInWorkspaceForm();

Returns: nothing (void)

Examples: Extension_RefreshDocument

DM_ReleaseProjectCopy​

No description yet.

IProject DM_ReleaseProjectCopy();

Returns: IProject

Extension method of IProjectHelper (using EDP;).

DM_RemoveAllConfigurations​

No description yet.

bool DM_RemoveAllConfigurations();

Returns: bool

DM_RemoveConfigurationByName​

No description yet.

bool DM_RemoveConfigurationByName(string argConfiguration);
ParameterTypePassing
argConfigurationstringvalue

Returns: bool

DM_RemoveProjectVariant​

No description yet.

void DM_RemoveProjectVariant(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: nothing (void)

DM_RemoveSourceDocument​

This method removes a source document referenced by its filename from this current project.

void DM_RemoveSourceDocument(string argFilename);
ParameterTypePassing
argFilenamestringvalue

Returns: nothing (void)

Examples: Extension_GenerateGerber

DM_ReportSuppressedErrorsInMessages​

No description yet.

bool DM_ReportSuppressedErrorsInMessages();

Returns: bool

DM_ResetReleaseProject​

No description yet.

void DM_ResetReleaseProject();

Returns: nothing (void)

DM_SearchPathCount​

The method returns the number of search paths for this current project. Use this method in conjunction with the DM_SearchPaths method.

int DM_SearchPathCount();

Returns: int

DM_SearchPaths​

The method returns the indexed search path object defined for this project.

ISearchPath DM_SearchPaths(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: ISearchPath

Extension method of IProjectHelper (using EDP;).

DM_ServerDocument​

No description yet.

IServerDocument DM_ServerDocument();

Returns: IServerDocument

Extension method of IProjectHelper (using EDP;).

DM_SetAllowPortNetNames​

Invoke this method to allow port net names be used for navigation.

void DM_SetAllowPortNetNames(bool argAllow);
ParameterTypePassing
argAllowboolvalue

Returns: nothing (void)

DM_SetAllowSheetEntryNetNames​

Invoke this method to allow sheet entry net names be used for navigation in Altium Designer.

void DM_SetAllowSheetEntryNetNames(bool argAllow);
ParameterTypePassing
argAllowboolvalue

Returns: nothing (void)

DM_SetAppendSheetNumberToLocalNets​

Invoke this method to have the ability to append sheet numbers to local nets on a document / project.

void DM_SetAppendSheetNumberToLocalNets(bool argAppend);
ParameterTypePassing
argAppendboolvalue

Returns: nothing (void)

DM_SetAsCurrentProject​

Invoke this method to set the project as the current project in Altium Designer.

void DM_SetAsCurrentProject();

Returns: nothing (void)

DM_SetCurrentProjectVariant​

No description yet.

void DM_SetCurrentProjectVariant(IProjectVariant argProjVariant);
void DM_SetCurrentProjectVariant(object argProjVariant);
ParameterTypePassing
argProjVariantIProjectVariantvalue

Returns: nothing (void)

The first overload is an extension method of IProjectHelper (using EDP;) with typed parameters; the second is declared by the interface.

DM_SetDefaultConfigurationName​

The method sets the name for the default configuration of a FPGA project.

void DM_SetDefaultConfigurationName(string argConfiguration);
ParameterTypePassing
argConfigurationstringvalue

Returns: nothing (void)

DM_SetDefaultPcbType​

No description yet.

void DM_SetDefaultPcbType(string argPcbType);
ParameterTypePassing
argPcbTypestringvalue

Returns: nothing (void)

DM_SetErrorLevels​

No description yet.

void DM_SetErrorLevels(TErrorKind argErrorKind, TErrorLevel argErrorLevel);
void DM_SetErrorLevels(int argErrorKind, int argErrorLevel);
ParameterTypePassing
argErrorKindTErrorKindvalue
argErrorLevelTErrorLevelvalue

Returns: nothing (void)

The first overload is an extension method of IProjectHelper (using EDP;) with typed parameters; the second is declared by the interface.

DM_SetHierarchyMode​

Invoke this method to set which hierarchy mode for this project. It can be one of the following modes: eFlatten_Smart,eFlatten_Flat,eFlatten_Hierarchical,eFlatten_Global

void DM_SetHierarchyMode(TFlattenMode argFlatten);
void DM_SetHierarchyMode(int argFlatten);
ParameterTypePassing
argFlattenTFlattenModevalue

Returns: nothing (void)

The first overload is an extension method of IProjectHelper (using EDP;) with typed parameters; the second is declared by the interface.

DM_SetLinkedManagedProjectGUID​

No description yet.

void DM_SetLinkedManagedProjectGUID(string argValue);
ParameterTypePassing
argValuestringvalue

Returns: nothing (void)

DM_SetManagedProjectGUID​

No description yet.

void DM_SetManagedProjectGUID(string argValue);
ParameterTypePassing
argValuestringvalue

Returns: nothing (void)

DM_SetOutputPath​

Sets the output path for generated documents to go in by the Altium Designer output generator.

void DM_SetOutputPath(string argnOutputPath);
ParameterTypePassing
argnOutputPathstringvalue

Returns: nothing (void)

DM_SetPinSwapBy_Netlabel​

No description yet.

void DM_SetPinSwapBy_Netlabel(bool argAllow);
ParameterTypePassing
argAllowboolvalue

Returns: nothing (void)

DM_SetPinSwapBy_Pin​

No description yet.

void DM_SetPinSwapBy_Pin(bool argAllow);
ParameterTypePassing
argAllowboolvalue

Returns: nothing (void)

DM_SetReleaseVaultGUID​

No description yet.

void DM_SetReleaseVaultGUID(string argValue);
ParameterTypePassing
argValuestringvalue

Returns: nothing (void)

DM_StartCrossProbing​

This method invokes the cross probing method. Both source and primary implementation documents need to be open in Altium Designer in order for the cross probing to work.

void DM_StartCrossProbing(bool argCtrlDoesSwitch);
ParameterTypePassing
argCtrlDoesSwitchboolvalue

Returns: nothing (void)

DM_StartNavigation​

This method invokes the navigation panel for the current project. The project needs to be compiled first.

void DM_StartNavigation();

Returns: nothing (void)

DM_ToDoManager​

Invoke this method to have access to the IToDoManager object. This ToDo manager allows you to define to dos for your current project.

IToDoManager DM_ToDoManager();

Returns: IToDoManager

Extension method of IProjectHelper (using EDP;).

DM_TopLevelLogicalDocument​

This method returns the top level logical document of this current project. A logical document is usually a Schematic document and can represent a document of a multi channel project for example.

IDocument DM_TopLevelLogicalDocument();

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_TopLevelPhysicalDocument​

This method returns the top level physical document of this current project. A physical document usually is a PCB document.

IDocument DM_TopLevelPhysicalDocument();

Returns: IDocument

Extension method of IProjectHelper (using EDP;).

DM_TryToResolveDocumentSpecialString​

No description yet.

bool DM_TryToResolveDocumentSpecialString(string argName, string argDocumentFileName, out string argValue);
ParameterTypePassing
argNamestringvalue
argDocumentFileNamestringvalue
argValuestringout

Returns: bool

DM_TryToResolveSpecialString​

No description yet.

bool DM_TryToResolveSpecialString(string argName, out string argValue);
ParameterTypePassing
argNamestringvalue
argValuestringout

Returns: bool

DM_UpdateConstraints​

Invoke this method to update the constraint files used for a FPGA project and for corresponding PCB projects with FPGA components.

bool DM_UpdateConstraints();

Returns: bool

DM_UserID​

The method returns a value that represents the UserID of the project.

string DM_UserID();

Returns: string

DM_ViolationCount​

This method returns the number of violations reported by Altium Designer for this current project.

int DM_ViolationCount();

Returns: int

DM_Violations​

Returns the indexed violation for a current project. This is to be used in conjunction with the DM_ViolationCount method.

IViolation DM_Violations(int argIndex);
ParameterTypePassing
argIndexintvalue

Returns: IViolation

Extension method of IProjectHelper (using EDP;).

GetNavigationHistory​

This method returns the status of the navigation buttons on the Navigator panel for the current project in Altium Designer. Check out INavigationHistory interface for details.

INavigationHistory GetNavigationHistory();

Returns: INavigationHistory

Extension method of IProjectHelper (using EDP;).

Inherited members​

Returned by​

IDocument.DM_Project, IOutputGenerator.GetProject, IProjectVariant.DM_Project, ISearchPath.DM_Project, IVaultConfigurationReleaseManager.DM_CurrentProject, IWorkspace.DM_FocusedProject, IWorkspace.DM_FreeDocumentsProject, IWorkspace.DM_GetProjectFromPath, IWorkspace.DM_LoadProjectHidden, IWorkspace.DM_OpenProject, IWorkspace.DM_Projects, IDeviceLink.GetFPGAProject, IDeviceLink.GetProject, IDeviceSheetManager.GetCurrentProject, INexusCore.GetEmbeddedProject, INexusCore.GetFPGAProject, INexusWorkbench.GetProjectFromDevice, IPCBProjectLink.GetProject, IProjectLink.GetProject

Accepted by​

IBomManagerFactory.GetManagerForProject, IBomManagerFactory.GetManagerForProjectPcb, IChangeManager.DM_SetProject1, IChangeManager.DM_SetProject2, IOutputGenerator.Initialize, IReleaseManager.GetAllReleasesBasePath, IVaultConfigurationReleaseManager.DM_Reload, IVaultConfigurationReleaseManager.DM_Reload_1, IWorkspace.DM_GetVaultReleaseManager, IWorkspace.DM_Navigation_OpenHostDocuments, IEmbeddedMemories.FromEmbeddedProject, IEmbeddedMemories.FromEmbeddedProjectDefault, IEmbeddedMemory.GetHexFileName, IEmbeddedMemoryManager.EmbeddedProjectHasExistingMemoryConfiguration, IEmbeddedMemoryManager.EraseEmbeddedProjectMemoryConfiguration, IEmbeddedMemoryManager.GetToolchainNameFromEmbeddedProject, IEmbeddedModule.CompileAGUIDesign, IMemoryDownloader.DownloadProgramMemory, IMemoryDownloader.GetNewestFileDateTime, IMemoryDownloader.SetupProgramMemory, IMemoryDownloader.VerifyProgramMemory, IImporterFile.Import, IPCB_Board3DModelExporter.ExportBoard3DModel, IPCB_Board3DModelExporter.ExportBoard3DModelToOCCDoc, IPCB_ModelOptions.GetSearchPaths, IDeviceSheetManager.MakeCurrentProject, IHardDeviceLink.SetHardDeviceProject, IIntegratedLibraryManager.CreateIntegratedLibrary, IIntegratedLibraryManager.MakeCurrentProject, INexusDevice.ConfigureFpgaProject, INexusDriver.ConfigureFpgaProject, INexusWorkbench.GetCoreFromDesignator, ISimProbeManager.LoadFromProject, IVHDLSynthesizer.VHDL_GetCoreFileExtension, IVHDLSynthesizer.VHDL_GetCurrentSynthesizer, IVHDLSynthesizer.VHDL_GetOutputFileExtension, IVHDLSynthesizer.VHDL_GetOutputPath, IVHDLSynthesizer.VHDL_GetReportFile, IVHDLSynthesizer.VHDL_GetToolchainRootPath, IVHDLSynthesizer.VHDL_GetTopLevelExtension, and 6 more.

Examples​

Used in the SDK examples: Ciiva, Ciiva, Extension_AddVariant, Extension_BOMManager, Extension_BOMManager, Extension_BOMManager, Extension_BOMManager, Extension_BOMManager, Extension_CreateProject, Extension_CreateVariantComponent, Extension_HierarchicalDesign, Extension_RefreshDocument.